unit mainu;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
  LCLIntf, LCLType, LMessages,
{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, ExtCtrls, rs232cu,Math;

type

{ Tmain }

 Tmain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
		Button8:TButton;
		Button9:TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button4: TButton;
    Button5: TButton;
		ComboBox3:TComboBox;
		ComboBox4:TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button6: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
		Memo3:TMemo;
		Memo4:TMemo;
    rs232c1: rs232c;
		rs232c2:rs232c;
    SpinEdit1: TSpinEdit;
    Edit3: TEdit;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
		procedure Button8Click(Sender:TObject);
		procedure Button9Click(Sender:TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: char);
		procedure Memo3KeyPress(Sender:TObject; var Key:char);
		procedure rs232c2RXCHAR(Sender:TObject);
    procedure rs232cRXCHAR(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rs232cOpen(Sender: TObject);
    procedure rs232cClose(Sender: TObject);
    procedure rs232cPACKET(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure rs232cRXFLAG(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
    rx_counter:integer;
  end;

var
  main: Tmain;

implementation

{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

procedure Tmain.Button1Click(Sender: TObject);
begin
  close;
end;

procedure Tmain.Button2Click(Sender: TObject);
begin
  with rs232c1 do
  begin
    bps:=strtointdef(combobox2.Items[ComboBox2.ItemIndex],38400);
//    portname:=combobox1.Items[ComboBox1.ItemIndex];
    portname:=combobox1.text;
    if rsopen()=false then
    begin
 //     messagebeep(MB_ICONASTERISK);
      showmessage('回線オープンエラー');
      exit;
    end;
  end;
  edit3.Text:='回線開きました';
  button3.enabled:=true;
  button2.enabled:=false;
  memo1.SetFocus;
end;

procedure Tmain.Button3Click(Sender: TObject);
begin
  rs232c1.rsclose;

  edit3.Text:='回線閉じました';
  button2.enabled:=true;
  button3.enabled:=false;
  memo1.SetFocus;
end;

procedure Tmain.Button8Click(Sender:TObject);
begin
  rs232c2.rsclose;
  button8.enabled:=false;
  button9.enabled:=true;
end;

procedure Tmain.Button9Click(Sender:TObject);
begin
	with rs232c2 do
	begin
	  bps:=strtointdef(combobox4.Items[ComboBox4.ItemIndex],38400);
	//    portname:=combobox1.Items[ComboBox1.ItemIndex];
	  portname:=combobox3.text;
	  if rsopen()=false then
	  begin
	//     messagebeep(MB_ICONASTERISK);
	    showmessage('回線オープンエラー');
	    exit;
	  end;
	end;
  button8.enabled:=true;
  button9.enabled:=false;
end;

procedure Tmain.Memo1KeyPress(Sender: TObject; var Key: char);
begin
  //漢字は入力できないけど...
  if button2.enabled=false then
    rs232c1.rswritechar(key);
end;

procedure Tmain.Memo3KeyPress(Sender:TObject; var Key:char);
begin
    rs232c2.rswritechar(key);
end;

procedure Tmain.rs232c2RXCHAR(Sender:TObject);
var
  moji1:char;
begin
  inc(rx_counter);
  edit2.text:=inttostr(rx_counter);

//	exit;

  //データを取り込む
  with rs232c2 do
  begin
    //データがあるだけ処理する
    while rxdatalen<>0 do
    begin
      if rsreadchar(moji1)=false then
        showmessage('データ読込みエラー');

      //改行コードなら改行
      //それ以外はそのまま文字を挿入する
      if moji1=#13 then
        memo4.Lines.add('')
      else
        memo4.text:=memo4.text+moji1;
    end;
  end;
end;

procedure Tmain.rs232cRXCHAR(Sender: TObject);
var
  moji1:char;
begin
  inc(rx_counter);
  edit2.text:=inttostr(rx_counter);

//	exit;

  //データを取り込む
  with rs232c1 do
  begin
    //データがあるだけ処理する
    while rxdatalen<>0 do
    begin
      if rsreadchar(moji1)=false then
        showmessage('データ読込みエラー');

      //改行コードなら改行
      //それ以外はそのまま文字を挿入する
      if moji1=#13 then
        memo2.Lines.add('')
      else
        memo2.text:=memo2.text+moji1;
    end;
  end;
{
  with memo2 do
  begin
    Perform(WM_VSCROLL,MakeWParam(SB_BOTTOM,0),0);
    Perform(WM_VSCROLL,MakeWParam(SB_ENDSCROLL,0),0);
  end;
}
//richedit1.SetFocus;
end;


procedure Tmain.FormCreate(Sender: TObject);
begin
  combobox1.itemindex:=0;
  combobox2.itemindex:=0;
end;

procedure Tmain.rs232cOpen(Sender: TObject);
begin
  rs232c1.set_dtr(true);
  rs232c1.set_rts(true);
end;

procedure Tmain.rs232cClose(Sender: TObject);
begin
  rs232c1.set_dtr(false);
  rs232c1.set_rts(false);
end;

procedure Tmain.rs232cPACKET(Sender: TObject);
var
  buffer:array[0..1024] of char;
begin
  showmessage('パケットサイズです');
  rs232c1.rsread(buffer,rs232c1.rxdatalen);
end;

procedure Tmain.Button4Click(Sender: TObject);
var
  buffer:array[0..4096] of char;
  size:integer;
begin
  if rs232c1.rxdatalen<>0 then
  begin
    size:=rs232c1.rxdatalen;
    rs232c1.rsread(buffer,size);
    buffer[size]:=#0;
    memo2.Lines.Add(buffer);
  end;
end;

procedure Tmain.Button5Click(Sender: TObject);
var
  data:array[0..1024] of char;
  counter:integer;
  size:integer;
begin
  //データをコピー
  size:=length(edit1.text);
  for counter:=0 to size do
    data[counter]:=edit1.text[counter+1];

  rs232c1.rswrite(data,size);
end;

procedure Tmain.Button6Click(Sender: TObject);
var
  data:array[0..102400] of char;
  data2:array[0..102400] of char;
  counter:integer;
  rand:real;
  flg:boolean;
  size:integer;
begin
  size:=spinedit1.Value;

  //ランダムデータを作成する
  edit3.text:='データ作成中';
  edit3.Update;
  for counter:=1 to size do
  begin
    rand:=random(3);
    rand:=rand*255;
    data[counter-1]:=char(trunc(rand));
  end;

  //データを送信する
  edit3.text:='データ送信中';
  edit3.Update;
  if rs232c1.rswrite(data,size)=false then
  begin
    edit3.text:='送信エラー発生';
    exit;
  end;

  edit3.text:='データ受信中';
  edit3.Update;
  if rs232c1.rsread(data2,size)=false then
  begin
    edit3.text:='受信エラー発生';
    exit;
  end;

  //一致しているか確認
  edit3.text:='データ照合中';
  edit3.Update;

  flg:=true;

  for counter:=1 to size do
  begin
    if data[counter-1]<>data2[counter-1] then
    begin
      flg:=false;
      break;
    end;
  end;

  if flg then
    edit3.text:='送受信正常'
  else
    edit3.text:='送受信異常';
end;

procedure Tmain.rs232cRXFLAG(Sender: TObject);
begin
  showmessage('#19が来た！');
end;

procedure Tmain.Button7Click(Sender: TObject);
begin
  rs232c1.rswritechar(#19);
end;



end.
